// g++ test.cpp

#include <math.h>
#include <cerf.h>
#include <stdio.h>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <sstream>

using namespace std;

const double PI = M_PI;
#define nj 200

double f0( double x, double s ) // angle dis
{
    return s/2*pow(x+s*s,-1.5);
}

double f1( double x, double s ) // res
{
    return exp(-x*x/2/s/s)/sqrt(2*PI*s*s);
}

double compute_y( double x, vector<double>& P )
{
    double sum = 0;
    double step = 22./nj;
    for( int j=0; j<nj; ++j ) {
        double si = j*step;
        for( int k=0; k<nj; ++k ) {
            double sf = k*step;
            sum += f0( si, P[2] ) * f0( sf, P[3] ) * voigt( x+si-sf, P[4], P[5] );
        }
    }
    return P[0] + P[1] * sum*step*step;
}

int main()
{
    int npar;
    cin >> npar;
    if( npar!=6 ) {
        cerr << "Unexpected #pars\n";
        return -1;
    }
    vector<double> P(npar);
    for( int ip=0; ip<npar; ++ip )
        cin >> P[ip];
    int nx;
    cin >> nx;
    vector<double> X(nx);
    vector<double> Y(nx);
    for( int i=0; i<nx; ++i )
        cin >> X[i];

    for( int i=0; i<nx; ++i )
        Y[i] = compute_y( X[i], P );
    
    for( int i=0; i<nx; ++i )
        cout << X[i] << " " << Y[i] << "\n";
}
