# Find libfftw3 (i.e. the double-precision version)
#
# Usage:
#   find_package(FFTW3 [REQUIRED] [QUIET])
#
# Sets the following variables:
#   - FFTW_FOUND        .. true if library is found
#   - FFTW_LIBRARIES    .. full path to library
#   - FFTW_INCLUDE_DIR  .. full path to include directory
#
# Copyright 2015 Joachim Wuttke, Forschungszentrum Jülich.
# Redistribution permitted.

find_path(FFTW_INCLUDE_DIR fftw3.h)
find_library(FFTW_LIBRARIES NAMES fftw3 FFTW3)

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(FFTW DEFAULT_MSG FFTW_LIBRARIES FFTW_INCLUDE_DIR)

include(AssertLibraryFunction)
assert_library_function(FFTW fftw_plan_r2r_1d "")

mark_as_advanced(FFTW_INCLUDE_DIR FFTW_LIBRARIES)
