//**************************************************************************************************
//*  FRIDA: fast reliable interactive data analysis
//*  (C) Joachim Wuttke 1990-, v2(C++) 2001-
//*  http://www.mesen-und-deuten.de/frida
//**************************************************************************************************

//! \file  ptr.hpp
//! \brief pointer forward declarations POlo, PNode, and so on (.h file only)

#ifndef PTR_H
#define PTR_H

#include <memory>

#define PCAST std::dynamic_pointer_cast

#define DEF_PTR(C, P, R)                                                                           \
    using P = std::shared_ptr<class C>;                                                            \
    using R = std::shared_ptr<const class C>

DEF_PTR(CObj, PObj, RObj);
DEF_PTR(CObjNum, PObjNum, RObjNum);
DEF_PTR(CObjInt, PObjInt, RObjInt);
DEF_PTR(CObjDbl, PObjDbl, RObjDbl);
DEF_PTR(CObjEnu, PObjEnu, RObjEnu);
DEF_PTR(CObjStr, PObjStr, RObjStr);
DEF_PTR(CObjVec, PObjVec, RObjVec);
DEF_PTR(CObjVecObj, PObjVecObj, RObjVecObj);
DEF_PTR(CObjVecNum, PObjVecNum, RObjVecNum);
DEF_PTR(CObjVecInt, PObjVecInt, RObjVecInt);
DEF_PTR(CObjVecDbl, PObjVecDbl, RObjVecDbl);
DEF_PTR(CObjVecEnu, PObjVecEnu, RObjVecEnu);

#undef DEF_PTR

using POlo = std::unique_ptr<class COlo>;
using POld = std::unique_ptr<class COld>;
using POlc = std::unique_ptr<class COlc>;
using PSlice = std::unique_ptr<class CSlice>;
using PSpec = std::unique_ptr<class CSpec>;
using PCurve = std::unique_ptr<class CCurve>;

using RNode = std::shared_ptr<const class CNode>;
using RRef = std::shared_ptr<const class CRef1>;

#endif // PTR_H
